\documentclass[a4paper,10pt]{article}

\renewcommand*{\tablename}{\small\textbf{Table}}
\renewcommand*{\figurename}{\small\textbf{Figure}}
\renewcommand*{\abstractname}{\small\textbf{Abstract}}

\begin{document}

\title{\textbf{Programmable Interrupt Controller}}
\author{Pawel Dziepak}
\date{\textit{January 09, 2009}}
\maketitle

\section{Role of the PIC}
\paragraph{}The main PIC task is to control all interrupts requests (IRQs) reported by
the hardware. In most computers there are two PIC microcontrollers, each control
eight IRQs. When a device reports IRQ, dependently on the PIC configuration
a CPU interrupt is performed, which allow the device driver to do all needed
things to keep device working.

\section{PIC configuration (ICW)}

\begin{table}
\begin{tabular}{ll}
\textbf{bit} & \textbf{meaning} \\
0 & if set, ICW4 will be sent \\
1 & if set there is only one PIC, zero means that there are two PICs \\
2 & always zeroed \\
3 & method of reporting IRQs \\
4-7 & signature of the command (0001b)
\end{tabular} 
\caption{ICW1}
\label{icw1}
\end{table} 

\begin{table}
\begin{tabular}{ll}
\textbf{bit} & \textbf{meaning} \\
0-2 & always zeroed \\
3-7 & offset of the interrupt vector (in translation IRQ-interrupt)
\end{tabular} 
\caption{ICW2}
\end{table} 

\begin{table}
\begin{tabular}{ll}
\textbf{bit} & \textbf{meaning} \\
0-7 & if bit on a specific position is set it means that it is \\
    & the place of the connection with slave PIC
\end{tabular} 
\caption{ICW3 (master)}
\end{table} 

\begin{table}
\begin{tabular}{ll}
\textbf{bit} & \textbf{meaning} \\
0-2 & slave PIC's ID, not really used in standard PCs \\
3-7 & always zeroed
\end{tabular} 
\caption{ICW3 (slave)}
\end{table} 

\begin{table}
\begin{tabular}{ll}
\textbf{bit} & \textbf{meaning} \\
0 & if set 8-bit interrupts vector will be used, if zeroed 16-bit \\
  & addressing will be used \\
1 & if set mode AEOI will be enabled what means that EOI message \\
  & will be sent automatically \\
2 & used to specify which controller is the command addressed to, \\
  & \textbf{only} when bit 3 is set \\
3 & if set buffered mode will be enabled, not used on standard PCs \\
4 & if set modifies method of transmission master-slave, not used \\
  &on standard PCs \\
7-5 & always zeroed \\
\end{tabular} 
\caption{ICW4}
\label{icw4}
\end{table} 

\paragraph{}PIC is once configured during system start. Then small changes in configuration
are performed only while loading or destroying device drivers (look at point 3,
Disabling/enabling IRQs).
\paragraph{}When PIC is initialized, correct connections CPU interrupt - IRQ are set. It is
done by sending ICWs (initialization command word). The first ICW is sent to the port \texttt{0x20} if
it is destinated for master or \texttt{0xA0} if for slave. The other ICWs are sent to the ports
\texttt{0x21} for master and \texttt{0xA1} for slave. ICW3 is sent only when there are two PICs in
the system. The command is different for master and for slave microcontroller. ICW4 is sent
only if first bit (bit 0) of ICW1 is set. Tables \ref{icw1} to \ref{icw4} presents the structure of each
ICW. After receiving all 4 commands PIC will be configured and ready to work.

\section{Disabling/enabling IRQs (OCW1)}
\paragraph{}After initialization the main PIC functionallity can be controlled by two
ports. They can be used to disable or enable specific IRQ the hardware way.
These control registers are bit fields where each bit represents one of the
IRQs. If bit is set IRQ is disabled. Accessing these registers can be done
by using command OCW1 (operation control word) which can be send by 
reading and/or writing to ports \texttt{0x21} (master PIC) and \texttt{0xA1} (slave PIC). Master
PIC controls IRQs 0-7, slave PIC controls IRQs 8-15.

\section{IRQs description}
\begin{table}
\begin{tabular}{ll}
\textbf{IRQ} & \textbf{Device }\\
0 & PIT \\
1 & keyboard \\
2 & slave PIC \\
3 & second serial port \\
4 & first serial port \\
5 & hard disk controller \\
6 & floppy disk controller \\
7 & paraell port \\
8 & real time clock \\
9 & not used \\
10 & not used \\
11 & not used \\
12 & ps/2 mouse \\
13 & FPU \\
14 & hard disk controller \\
15 & hard disk controller
\end{tabular}
\caption{Devices assigned to specific IRQs}
\label{irqs}
\end{table} 

\paragraph{}IRQs are used to allow hardware to inform CPU that some event has happened.
Each IRQ is assigned to a certain device. Table \ref{irqs} shows which device calls which
IRQ. Positions marked as \textit{not used} are reserved for PCI and/or other buses automatic
configuration.

\end{document}
